%%
% Matlab code used to analyze the data. If you would like to use this code
% please contact efreud@yorku.ca for more instructions 
%%

%voxel data from BV. The code correlates and calculate reg. coff between different 
 %mni cord (y/z) and the linear slope. 
clear all;
clear all;
no_cat_flag=1 %no category = change to 1

%adults
%path = '/Users/efreud/Dropbox/postdoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/';
%office computer
path = '/Users/efreud/Dropbox/PostDoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/';

subjects={'160224104136','160224122535','160301110546','160307093730','160307111751','160307130827','160310120847'...
    '160420131627','160421091747','160427140455','160510164658','190306155635','190307160031','190308162246','190312111405','190703095718-TCK2019','180606153901','160329120605'}


pred=3; %how many predictors (2 - y and z /3 x y z)
roi = {'ventral_r','ventral_l','dorsal_r','dorsal_l'}; %dont change the order of rois

x=1:5;

group_voxels=cell(397456,9,length(roi));
for r=1:4
   A = importdata(['/Users/efreud/Dropbox/postdoc/Parametric_scrambling_RSA/RSA_Dorsal_Cortex/group/voxel analysis/' roi{r} '_exp1and2_mni_REVISION.txt'],' ',24);

    temp=A.data;
    temp1=sortrows(temp, [4,6,8,10]);
    temp_final=num2cell(temp1);
    group_t=temp_final(:,[1 2 3 4 6 8 10 12]);  
    clear temp_final
    clear temp1
    clear temp
    clear A
    for v=2:length(group_t)
    if cell2mat(group_t(v-1,6))==cell2mat(group_t(v,6)) %reduce resampled voxels
    group_voxels(v,4:9,r)=num2cell(NaN);
    group_voxels(v,1:3,r)=group_t(v,1:3);

    else
        if r>2
            if ((cell2mat(group_t(v,4))>2.6 || cell2mat(group_t(v,5))>2.6  || cell2mat(group_t(v,6))>2.6 || cell2mat(group_t(v,7))>2.6)  || cell2mat(group_t(v,8))>2.6) 
            group_voxels(v,1:8,r)=group_t(v,:);
            group_voxels(v,9,r)=num2cell(v);

            else
            group_voxels(v,4:9,r)=num2cell(NaN);
            group_voxels(v,1:3,r)=group_t(v,1:3);
            end
        else
            if (cell2mat(group_t(v,4))>2.6 || cell2mat(group_t(v,5))>2.6  || cell2mat(group_t(v,6))>2.6  || cell2mat(group_t(v,7))>2.6)  || cell2mat(group_t(v,8))>2.6 
            group_voxels(v,1:8,r)=group_t(v,:);
            group_voxels(v,9,r)=num2cell(v);

            else
            group_voxels(v,4:9,r)=num2cell(NaN);
            group_voxels(v,1:3,r)=group_t(v,1:3);
            end
            
            
        end
    end
            group_voxels(1,4:9,r)=num2cell(NaN);
            group_voxels(1,1:3,r)=group_t(v,1:3);
    end
    
end
    
 ventral_right_voxels=sortrows( cell2mat(group_voxels(:,:,1)),[9,1 -2 3]); 
 ventral_left_voxels=sortrows( cell2mat(group_voxels(:,:,2)),[9,-1,-2,3]); 
 dorsal_right_voxels=sortrows( cell2mat(group_voxels(:,:,3)),[9,1,-2,3]); 
 dorsal_left_voxels=sortrows( cell2mat(group_voxels(:,:,4)),[9,-1,-2,3]);
  clear group_voxels group_t

 ventral_right= nan(sum(~isnan(ventral_right_voxels(:,9))),9,length(subjects));
 ventral_left=nan(sum(~isnan(ventral_left_voxels(:,9))),9,length(subjects));
 dorsal_right=nan(sum(~isnan(dorsal_right_voxels(:,9))),9,length(subjects));
 dorsal_left=nan(sum(~isnan(dorsal_left_voxels(:,9))),9,length(subjects));
 
for s= 1:length(subjects)
    for r=1:length(roi)
    
    A = importdata([path subjects{s} '/voxel analysis/' roi{r} '_mni_revision.txt'],' ',24);
       
    
    temp=A.data;
    if r==1
        for v=1:length(ventral_right)
        temp_intersect=intersect(intersect(find((temp(:,1))==ventral_right_voxels(v,1)),find((temp(:,2))==ventral_right_voxels(v,2))),find((temp(:,3))==ventral_right_voxels(v,3)));
        ventral_right(v,1:8,s)=(temp(temp_intersect,[1 2 3 4 6 8 10 12])); 
                
        slopeO=polyfit(x,ventral_right(v,4:8,s),1);
        ventral_right(v,9,s)=slopeO(1); %objects

        end
    elseif r==2
       for v=1:length(ventral_left)
        temp_intersect=intersect(intersect(find((temp(:,1))==ventral_left_voxels(v,1)),find((temp(:,2))==ventral_left_voxels(v,2))),find((temp(:,3))==ventral_left_voxels(v,3)));
        ventral_left(v,1:8,s)=(temp(temp_intersect,[1 2 3 4 6 8 10 12])); 
                
        slopeO=polyfit(x,ventral_left(v,4:8,s),1);
        ventral_left(v,9,s)=slopeO(1);

       end
    elseif r==3

       for v=1:length(dorsal_right)
        temp_intersect=intersect(intersect(find((temp(:,1))==dorsal_right_voxels(v,1)),find((temp(:,2))==dorsal_right_voxels(v,2))),find((temp(:,3))==dorsal_right_voxels(v,3)));
        dorsal_right(v,1:8,s)=(temp(temp_intersect,[1 2 3 4 6 8 10 12])); 
                
        slopeO=polyfit(x,dorsal_right(v,4:8,s),1);
        dorsal_right(v,9,s)=slopeO(1);
       end
    else
        for v=1:length(dorsal_left)
        temp_intersect=intersect(intersect(find((temp(:,1))==dorsal_left_voxels(v,1)),find((temp(:,2))==dorsal_left_voxels(v,2))),find((temp(:,3))==dorsal_left_voxels(v,3)));
        dorsal_left(v,1:8,s)=(temp(temp_intersect,[1 2 3 4 6 8 10 12])); 
                
        slopeO=polyfit(x,dorsal_left(v,4:8,s),1);
        dorsal_left(v,9,s)=slopeO(1);
        end
    end
    end
             a=s
  
end



%move voxels from ventral to dorsal based on z location
th=3
right_indx=find(ventral_right(:,3,1)>th);
dorsal_right_add=ventral_right(right_indx,:,:);
ventral_right([right_indx],:,:)=[];

left_indx=find(ventral_left(:,3,1)>th);
dorsal_left_add=ventral_left(left_indx,:,:);
ventral_left([left_indx],:,:)=[];

dorsal_left=cat(1,dorsal_left,dorsal_left_add);
dorsal_right=cat(1,dorsal_right,dorsal_right_add);

        
 ventral_right_avg=nanmean(ventral_right(:,:,1:length(subjects)),3);
 ventral_right_std=nanstd(ventral_right(:,9,1:length(subjects)),0,3);
 
 dorsal_right_avg=nanmean(dorsal_right(:,:,1:length(subjects)),3);
dorsal_right_std=nanstd(dorsal_right(:,9,1:length(subjects)),0,3);

 ventral_left_avg=nanmean(ventral_left(:,:,1:length(subjects)),3);
ventral_left_std=nanstd(ventral_left(:,9,1:length(subjects)),0,3);

 
 dorsal_left_avg=nanmean(dorsal_left(:,:,1:length(subjects)),3);
dorsal_left_std=nanstd(dorsal_left(:,9,1:length(subjects)),0,3);
%% scatter of slope versus x y and z coordiantes
%%
%reverse slopes (negative to positive)
ventral_right_avg(:,9)=-ventral_right_avg(:,9);
ventral_left_avg(:,9)=-ventral_left_avg(:,9);
dorsal_right_avg(:,9)=-dorsal_right_avg(:,9);
dorsal_left_avg(:,9)=-dorsal_left_avg(:,9);
%reverse slopes (negative to positive)
ventral_right(:,9,:)=-ventral_right(:,9,:);
ventral_left(:,9,:)=-ventral_left(:,9,:);
dorsal_right(:,9,:)=-dorsal_right(:,9,:);
dorsal_left(:,9,:)=-dorsal_left(:,9,:);
reverse='done'
